function resid = recycle_reactor(x,p)
    Na1 = x(1);
    Na2 = x(2);
    if (p.ntype == 1)
        Na3 = x(3);
        alpha = p.alpha;
        ktheta = p.ktheta;
    elseif (p.ntype == 2)
        Na3 = p.Na3;
        alpha = x(3);
        ktheta = p.ktheta;
    else
        error ('recycle_reactor: ntype out of range')
    end%if
    % reactor balance
    % feed mixer
    % outlet splitter
    resid = [(1 + ktheta/Na1)*Na2 - Na1;
	     alpha*Na2 + 1 - Na1;
	     Na3 - (1 - alpha)*Na2];