function xdot = ivpjbr(t, x, p, initial)
    Nnh = x(1);
    T   = x(2);
    Ta  = x(3);
    RT  = p.R*T;
    Nn = initial.Nn0 - 1/2*(Nnh - initial.Nnh0);
    Nh = initial.Nh0 - 3/2*(Nnh - initial.Nnh0);
    Nt = Nn + Nh + Nnh;
    pn = (Nn/Nt)*p.P;
    ph = (Nh/Nt)*p.P;
    pnh = (Nnh/Nt)*p.P;
    qadd = (Ta - T)*p.UA;
    k    = p.k0*exp(-p.E/T);
    K = p.K0*exp(-p.delH0/p.Rg*(1/T - 1/p.Tstd));
    rxrate  = k/RT* ( K^2 * pn*ph^(1.5)/pnh - pnh/ph^(1.5) );
    xdot = zeros(3, 1);
    xdot(1) = p.A * 2*rxrate;
    xdot(2) = qadd - rxrate*p.deltaH;
    xdot(3) = qadd;