function xdot = pbr (t, x, p)
    Nco = x(1);
    Nt  = p.No2f + (Nco + p.Ncof)/2 + p.NIf;
    cco = p.P/(p.Rg*p.T) * Nco/Nt;
    phi = p.Kco*cco;
    Phi = phi/(1 + phi) * sqrt(p.k*p.a^2/...
            (2*p.Dco* (phi - log(1 + phi)) ));

    if (Phi <= 1.0)
        eta = 1.0;
    else
        eta = 1./Phi;
    end

    xdot = -p.rhob/p.rhop*eta*p.k*cco/(1 + p.Kco*cco);