function rhs = particles(x, ncolpt, p, col)

    ca = x(1:ncolpt);
    cb = x(ncolpt+1:2*ncolpt);
    cabar = x(2*ncolpt + 1);
    cbbar = x(2*ncolpt + 2);

    inta = col.Qz'*(ca .* col.p);
    intb = col.Qz'*(cb .* col.p);
    rx =  p.k1 * ca.*cb;
    intrx = p.thetabar*col.Qz'*(rx .* col.p);
    first = [col.A*ca; col.A*cb];
    rhs = first - [p.kma*3/p.r*(cabar - ca) + rx;
                   p.kmb*3/p.r*(cbbar - cb) + rx];

    % initial condition
    rhs(1) = ca(1) - p.caf;
    rhs(ncolpt + 1) = cb(1);

    % total balances
    rhs(2*ncolpt+1) = p.caf - inta - intrx - ...
                      p.k1*cabar*cbbar*p.thetabar/p.alpha - ...
                      cabar/p.alpha;
    rhs(2*ncolpt+2) = p.cbf - p.alpha*intb - p.alpha*intrx -...
                      p.k1*cabar*cbbar*p.thetabar - cbbar;