function xdot = res_reduced(time, x, p)
    %	Passed variable                  Local equivalent
    %
    %	x(1)                             reactor contents volume
    %	x(2)                             extent of second reaction
    %
    vrdiclo = p.theta(1);
    k1k2ratio = p.theta(2);
    vr = x(1);

    if ( vr <= 0.0 )
        error ('(res_reduced).... vr is zero, time= %d',time);
    end

    eps2   = x(2);
    badded = (vr - p.vro)*p.teaf;
    eps1   = badded - eps2;

    % look up flowrate at current time
    [index, is_switching_time] = find_time_index(p.tflow, time);
    fteaf   = p.flowrate(index) * p.teaf;

    %	calculate xdots
    xdot(1) = p.flowrate(index);

    if (badded == 0.)
        xdot(2) = 0.;
    else
        xdot(2) = fteaf/( 1 + p.k1k2ratio*(vrdiclo - (badded - eps2) )/...
                    (badded - 2*eps2) );
    end
    xdot = xdot(:);